Dim sFirmware : sFirmware = "firmware.prn"
Dim sData : sData = "data.prn"
Dim sDefaultIP : sDefaultIP = "192.168.0.21"
Dim sIPAddress

Dim wshShell, fso, tempDir, tempFileName, fTemp
Const fsoForReading = 1, fsoForWriting = 2

Dim objShell

Dim strMsg, inp01, inp01loop

Function GetTempFileContent()
    Dim f
    Set f = fso.GetFile(tempFileName)
    If f.Size > 0 then
        Set f = fso.OpenTextFile(tempFileName, fsoForReading)
        GetTempFileContent = f.ReadAll
        f.Close
    End If    
End Function

Sub SaveTempFileContent(text)
    Dim f
    Set f = fso.OpenTextFile(tempFileName, fsoForWriting)
    f.Write text
    f.Close
End Sub

Function GetDate()
    GetDate = DateDiff("s", "01/01/1970 00:00:00", Now())
End Function

Function Printer_Check4Idle(TimeInSecs)
    Dim START_T, CHECK, PRT_STATUS, ERG, ErrCode
    Dim f
    
    START_T=GetDate
    CHECK=1
    Do While CHECK = 1
        ret = objShell.Run("cmd /C printf \x01SE\x17 | %TEMP%\itfsend -d -s" & sIPAddress & " -p9099 -r1 -o" & tempDir & "\itfsend.log", 1, True)
        Set f = fso.GetFile(tempDir & "\itfsend.log")
        If f.Size > 0 then
            Set f = fso.OpenTextFile(tempDir & "\itfsend.log", fsoForReading)
            PRT_STATUS = f.ReadAll            
            f.Close
        End If
        PRT_STATUS=Mid(PRT_STATUS, 2, 5)
        If StrComp(PRT_STATUS,"#Idle") = 0 Or StrComp(PRT_STATUS,"#Erro") = 0 Then
            ErrCode=0
        Else
            ErrCode=1
        End If
        If Not ErrCode = 0 Then
            ERG=GetDate-START_T
            If ERG > TimeInSecs Then
                CHECK=0
            End If
        Else
            CHECK=0
        End If
    Loop
    
    If ErrCode = 0 Then
        Printer_Check4Idle = True
    Else
        Printer_Check4Idle = False
    End If
End Function

Set wshShell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")
tempDir = wshShell.ExpandEnvironmentStrings("%TEMP%") 
tempFileName = tempDir & "\PrinterUpdate.ini"
If Not fso.FileExists(tempFileName) Then
    Set fTemp = fso.CreateTextFile(tempFileName, False)
    fTemp.close
End If

Set objShell = CreateObject("WScript.Shell")

sIPAddress = GetTempFileContent

' itfsend nach temp kopieren wegen evtl. Probleme beim Ausfhren von Netzlaufwerken (Rechte und so)
objShell.Run "cmd /C copy /Y itfsend.exe %TEMP%"

' Main Menue
strMsg =          "1. Update to " & sDefaultIP & vbCR
strMsg = strMsg & "2. Update to " & sIPAddress & vbCR
strMsg = strMsg & "or Enter New IP-Address" & vbCR
inp01loop = True
Do While inp01loop
inp01 = InputBox(strMsg, "Printer Update")
Select Case inp01
    Case ""
        WScript.Quit(1)
    Case "1"
        sIPAddress = sDefaultIP
        inp01loop = False
    Case "2"
        inp01loop = False
    Case Else
        If Len(inp01) = 1 then
            MsgBox "Incorrect input!" & vbCR & "Enter selection (i.e. '1') or IP-Address"
        Else
            sIPAddress = inp01
            SaveTempFileContent(sIPAddress)
            inp01loop = False
        End If
End Select
Loop

' Update Firmware
objShell.Run "cmd /C %TEMP%\itfsend -r*9 -l -m1 -t -s" & sIPAddress & " -i" & sFirmware, 1, True
If Not Printer_Check4Idle(20) Then
    MsgBox "Printer Restart Failed", 0, "Error" 
    WScript.Quit(0)
End If

' Update Data
objShell.Run "cmd /C %TEMP%\itfsend -r*9 -l -m1 -t -s" & sIPAddress & " -i" & sData, 1, True

WScript.Quit(0)
